#pragma once

#include <QGeoCoordinate>
#include <QObject>

#include "ros_bridge/include/messages/geographic_msgs/geopoint.h"


typedef ros_bridge::messages::geographic_msgs::geo_point::GeoPoint ROSGeoPoint;
class GeoPoint3D : public QObject, public ROSGeoPoint
{
    Q_OBJECT
public:

    GeoPoint3D(QObject *parent = nullptr);
    GeoPoint3D(double latitude,
               double longitude,
               double altitude,
               QObject *parent = nullptr);
    GeoPoint3D(const GeoPoint3D& p,
               QObject *parent = nullptr);
    GeoPoint3D(const ROSGeoPoint& p,
               QObject *parent = nullptr);
    GeoPoint3D(const QGeoCoordinate& p,
               QObject *parent = nullptr);

    GeoPoint3D &operator=(const GeoPoint3D&p);
    GeoPoint3D &operator=(const QGeoCoordinate&p);

};


